package com.coixinera.footprintscollector;

import java.io.File;
import java.io.IOException;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.Bundle;
import android.provider.MediaStore;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TableLayout;

import com.coixinera.footprintsDB.FootPrints_DAO;
import com.google.android.gms.maps.model.LatLng;

//Clase que sirve para gestionar tanto la creacin de sitios nuevos como la edicin de Sitios existentes.
//Utilizo una instancia de FootPrintsDAO para gestionar los accesos a la base de datos.
//Utilizo el valor de "id" que me llega del intent a travs de PutExtra para saber si vengo de un sitio
//existente o tengo que crear uno nuevo. este parametro tambien me sirve para modificar el layout en su parte
//final, inflando los botones de "guardar""eliminar" si estoy editando, o solamente el boton "crear" si estoy
//creando

public class EditarLugar_Fragment extends Fragment {

	EditText editNombre, editDescripcion, editLatitud, editLongitud;
	ImageView editImgFoto;
	Button btnGuardar, btnEliminar, btnCrear;
	final FootPrints_DAO dao = new FootPrints_DAO();

	// valores int estaticos para utilizarlos en los intents con
	// StartactivityForResult
	private static final int REQUEST_CAMERA = 1000;
	private static final int REQUEST_GALERIA = 2000;
	private Uri imageUri;
	TableLayout table;

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		// TODO Auto-generated method stub

		return inflater.inflate(R.layout.editar_lugar_fragment, container,
				false);

	}

	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onActivityCreated(savedInstanceState);

		View vista = getView();

		editNombre = (EditText) vista.findViewById(R.id.edit_campo_nombre);
		editDescripcion = (EditText) vista
				.findViewById(R.id.edit_campo_descripcion);
		editLatitud = (EditText) vista.findViewById(R.id.edit_campo_latitud);
		editLongitud = (EditText) vista.findViewById(R.id.edit_campo_longitud);

		editImgFoto = (ImageView) vista.findViewById(R.id.editimg_campo_foto);

		editImgFoto.setOnClickListener(new ImageView.OnClickListener() {

			@Override
			public void onClick(View v) {
				// derivo a un mtodo creado para gestionar la carga de la foto
				// segn se quiera
				// de la camara o de la galeria
				camara_o_galeria();
			}
		});
		// Si la actividad ya exisitia y hemos vuelto a ella recuperamos el
		// valor "uri"
		// para tenerlo disponible otra vez y poder recargar la imagen
		if (savedInstanceState != null && savedInstanceState.containsKey("Uri")) {
			imageUri = Uri.parse(savedInstanceState.getString("Uri"));
			getImage(imageUri);
		}

		// Instancio el Layoutinflater. Lo utilizare para inlflar los botones
		// que me convengan segn
		// si estoy editando o creando

		LayoutInflater inflater = (LayoutInflater) getActivity()
				.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
		TableLayout table = (TableLayout) vista
				.findViewById(R.id.layout_editar_lugar);
		// si vengo de edicin este valor id ser positivo, si vengo del mapa
		// estoy creando
		// y el valor id no existir por lo que el sistema me asignar el valor
		// por defecto (0)
		final int id = getActivity().getIntent().getIntExtra("id", 0);

		// Si id es 0, estoy creando, luego tengo que inflar el layout con el
		// botn crear que tengo
		// en un layout a parte. recupero el boton, y le asigno un listener de
		// click que llama al mtodo
		// crear lugar, que crea un objeto Lugar y se lo manda al DAO para que
		// lo inserte.
		if (id == 0) {
			inflater.inflate(R.layout.layout_btn_crear, table);
			btnCrear = (Button) vista.findViewById(R.id.btn_crear);
			btnCrear.setOnClickListener(new Button.OnClickListener() {

				@Override
				public void onClick(View v) {
					Lugar lugar = crearLugar();
					dao.insertarLugar(lugar, getActivity());
					getActivity().finish();
				}
			});
			String latitud = String.valueOf(getActivity().getIntent()
					.getDoubleExtra("latitud", 0));
			editLatitud.setText(latitud);
			// este campo lo deshabilito por que el valor del mismo ya me ha
			// llegado a travs del click
			// del mapa y el usuario no ha de poder retocarlo
			editLatitud.setEnabled(false);

			String Longitud = String.valueOf(getActivity().getIntent()
					.getDoubleExtra("longitud", 0));
			editLongitud.setText(Longitud);
			// este campo lo deshabilito por que el valor del mismo ya me ha
			// llegado a travs del click
			// del mapa y el usuario no ha de poder retocarlo
			editLongitud.setEnabled(false);

			// Si id no es 0, entonces vengo de un lugar existente y estoy en
			// modo edicin. tengo que inflar los
			// dos botones "guardar""eliminar" y darles la funcionalidad que les
			// toca a travs de los listeners de click

		} else {

			inflater.inflate(R.layout.layout_btn_guardar_eliminar, table);
			btnGuardar = (Button) vista.findViewById(R.id.btn_guardar);
			btnEliminar = (Button) vista.findViewById(R.id.btn_eliminar);

			// consulto el Lugar en la base de datos a travs del id, para
			// cargar los datos actuales
			Lugar lugar = dao.consultarLugar(id, getActivity());

			// cargo los datos del lugar en los editText para que puedan ser
			// manipulados
			editNombre.setText(lugar.getNombre());
			editDescripcion.setText(lugar.getDescripcion());

			String latitud = String.valueOf(lugar.getCoordenadas().latitude);
			editLatitud.setText(latitud);
			editLatitud.setEnabled(false);

			String Longitud = String.valueOf(lugar.getCoordenadas().longitude);
			editLongitud.setText(Longitud);
			editLongitud.setEnabled(false);

			// aqui utilizo el mtodo personalizado BitmapGetter.getbitmap para
			// conseguir el bitmap
			// correspondiente a travs de la uri que me llega y poder cargarlo
			// en la imageView
			Bitmap bitmap = BitmapGetter.getBitmap(lugar.getFoto(),
					getActivity());
			if (bitmap != null) {
				editImgFoto.setImageBitmap(bitmap);
			}

			btnGuardar.setOnClickListener(new Button.OnClickListener() {

				@Override
				public void onClick(View v) {
					// Hemos pulsado guardar. recupero los datos de los campos y
					// creo un objeto lugar a travs del mtodo crearLugar()
					// y lo mando al dao para que haga el Update. luego
					// Luego vuelvo a la pantalla de mostrarLugar. con el
					// flag FLAG_ACTIVITY_CLEAR_TOP, consigo que actualize
					// los datos ya que no aprovecha la actividad existente de
					// la pila
					// sino que la crea de nuevo y renueva los datos
					Lugar lugar = crearLugar();
					dao.editarLugar(getActivity(), id, lugar);
					getActivity().finish();
					Intent i = new Intent();
					i.putExtra("id", id);
					i.setClass(getActivity(), MostrarLugar_Activity.class);
					i.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
					startActivity(i);

				}
			});

			btnEliminar.setOnClickListener(new Button.OnClickListener() {

				@Override
				public void onClick(View v) {
					// hemos pulsado eliminar.llamo al dao y le paso el id del
					// registro que quiero
					// que elimine. Luego Vuelvo a ListaLugares directamente.si
					// Hiciese simplemente
					// finish volveria a MostraLugar, cosa que no tiene sentido
					// por que mostraria
					// un Lugar que ya no existe. Vuelvo a ListaLugares
					// directamente y con FLAG_ACTIVITY_CLEAR_TOP
					// elimino las actividades intermedias por encima de la pila
					// para conservar la lgica de funcionamiento
					// de la misma
					dao.eliminarLugar(id, getActivity());
					getActivity().finish();
					Intent i = new Intent();
					i.setClass(getActivity(), ListaLugares_Activity.class);
					i.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
					startActivity(i);
				}
			});

		}

	}

	private void camara_o_galeria() {

		// mtodo que pregunta primero a travs de un dialogBuilder si quieres
		// utilizar la camara o
		// la galeria para recuperar una imagen.y lanza los mtodos
		// correspondientes para utilizar
		// la cmara o la galeria. Los mtodos propiamente dichos los he sacado
		// de unos tutoriales de
		// internet y se basan en lanzar el intentcorrespondiente y con un
		// Activityforresult capturan
		// el request code para saber que acciones tienen que realizar para
		// obtener y asignar el Bitmap
		// a la imageview

		AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
		builder.setTitle(R.string.camara_o_galeria);
		builder.setPositiveButton(R.string.txt_dialog_camara,
				new AlertDialog.OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int which) {
						File f = null;
						Intent intent = new Intent();
						try {
							intent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
							f = createTemporaryFile("picture", ".jpg",
									getActivity());
							f.delete();

						} catch (IOException e) {
							e.printStackTrace();
						} catch (Exception e) {

							e.printStackTrace();
						}
						// aqui hemos guardado el Uri, para luego utilizarlo en
						// el onActivityResult
						// en el caso de que vengamos de la camara
						imageUri = Uri.fromFile(f);
						intent.putExtra(MediaStore.EXTRA_OUTPUT, imageUri);
						startActivityForResult(intent, REQUEST_CAMERA);
					}
				});
		builder.setNegativeButton(R.string.txt_dialog_galeria,
				new AlertDialog.OnClickListener() {

					@Override
					public void onClick(DialogInterface dialog, int which) {
						Intent galleryIntent = new Intent(
								Intent.ACTION_GET_CONTENT);
						galleryIntent.setType("image/*");
						startActivityForResult(galleryIntent, REQUEST_GALERIA);
					}
				});
		builder.create();
		builder.show();

	}

	@Override
	public void onActivityResult(int requestCode, int resultCode, Intent data) {
		// capturamos el request code para saber si venimos de camara o galeria
		if (requestCode == REQUEST_GALERIA
				&& resultCode == getActivity().RESULT_OK) {
			// venimos de galeria, luego en data tenemos una URI, que cargamos
			// en nuestro campo
			// imageUri. llamamos al mtodo getimage y le pasamos la Uri. este
			// metdo recupera y asigna
			// la imagen al ImageView de la Activity
			imageUri = data.getData();
			getImage(imageUri);
		} else if (requestCode == REQUEST_CAMERA
				&& resultCode == getActivity().RESULT_OK) {
			// venimos de la cmara. luego previamente ya hemos guardado el
			// valor que nos interesa
			// en imageUri. Solo tenemos que llamar a getImage para cargar la
			// imagen
			getImage(imageUri);
		}

	}

	// mtodo auxiliar para crear un fichero temporal y poder darle un nombre,y
	// asi obtener la Uri
	// del mismo
	public static File createTemporaryFile(String part, String ext,
			Context myContext) throws Exception {
		File tempDir = myContext.getExternalCacheDir();
		tempDir = new File(tempDir.getAbsolutePath() + "/temp/");
		if (!tempDir.exists()) {
			tempDir.mkdir();
		}
		return File.createTempFile(part, ext, tempDir);
	}

	@Override
	public void onSaveInstanceState(Bundle outState) {
		super.onSaveInstanceState(outState);
		// la actividad pasa a segundo plano. guardamos el valor de la Uri para
		// no perderlo
		// y tenerlo disponible cuando la actividad vuelva a primer plano.
		if (imageUri != null)
			outState.putString("Uri", imageUri.toString());
	}

	// metodo auxiliar para crear y asignar un bitmap al ImageView a travs de
	// la Uri que
	// se le pasa
	public void getImage(Uri uri) {
		Bitmap bitmap = BitmapGetter.getBitmap(uri, getActivity());
		if (bitmap != null) {
			editImgFoto.setImageBitmap(bitmap);
		} else {

		}
	}

	// mtodo auxiliar que cada vez que es llamado crea y devuelve un objeto
	// Lugar con los datos
	// existentes en ese momento en el formulario en pantalla
	public Lugar crearLugar() {

		Lugar lugar = new Lugar();
		lugar.setNombre(editNombre.getText().toString());
		lugar.setDescripcion(editDescripcion.getText().toString());
		lugar.setCoordenadas(new LatLng(Double.valueOf(editLatitud.getText()
				.toString()), Double.valueOf(editLongitud.getText().toString())));
		if (imageUri != null) {
			lugar.setFoto(imageUri);
		} else {
			lugar.setFoto(Uri
					.parse("android.resource://com.coixinera.footprintscollector/drawable/footprint"));
		}

		return lugar;

	}

}
