package com.coixinera.footprintscollector;

import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ListView;

import com.coixinera.footprintsDB.FootPrints_DAO;

public class ListaLugares_Fragment extends Fragment {

	private ListView lstLugares;
	AdaptadorListaLugares adapter;
	EditText editTxtBuscar;
	ImageButton botonBuscar;
	FootPrints_DAO dao = new FootPrints_DAO();
	String filtro;

	// Clase que utiliza el DAO y un listView para mostrar una lista de Lugares
	// Y que tiene un listener sobre el click del Item, para lanzar una pantalla
	// de MostrarLugar con los datos del lugar seleccionado

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		return inflater.inflate(R.layout.lista_lugares_fragment, container,
				false);
	}

	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onActivityCreated(savedInstanceState);

		// recupero el ListView. el boton y el edittext
		lstLugares = (ListView) getView().findViewById(R.id.Lst_lista_lugares);
		editTxtBuscar = (EditText) getView().findViewById(R.id.edit_txt_buscar);
		botonBuscar = (ImageButton) getView().findViewById(
				R.id.btn_boton_buscar);

		// creo una instancia de mi adapterPersonalizado llamando al
		// dao.consultarListaLugares, que devuelve precisamente un objeto
		// AdaptadorListaLugares. Luego lo asigno al ListView para poder ver los
		// datos
		adapter = dao.consultarListaLugares(getActivity(), null);
		lstLugares.setAdapter(adapter);

		lstLugares.setOnItemClickListener(new ListView.OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> adapter, View view,
					int position, long id) {
				// Hemos hecho click en un item. Lanzo actividad MostrarLugar,
				// pasndole el id del item seleccionado para que sepa de que
				// registro tiene que mostrar los datos

				Intent intent = new Intent();
				intent.putExtra("id", (int) id);
				intent.setClass(getActivity(), MostrarLugar_Activity.class);
				startActivity(intent);
			}
		});

		botonBuscar.setOnClickListener(new ImageButton.OnClickListener() {

			@Override
			public void onClick(View v) {
				filtro = editTxtBuscar.getText().toString();
				adapter = dao.consultarListaLugares(getActivity(), filtro);
				lstLugares.setAdapter(adapter);

				// Ocultamos el teclado para que se vea bien el resultado de la
				// busqueda
				InputMethodManager teclado = (InputMethodManager) getActivity()
						.getSystemService(getActivity().INPUT_METHOD_SERVICE);
				teclado.hideSoftInputFromWindow(editTxtBuscar.getWindowToken(),
						0);

			}
		});

	}

	@Override
	public void onResume() {
		// venimos de estar en segundo plano. reasigno el adapter para refrescar
		// los datos de la lista, por si algun registro ha cambiado o ha sido
		// eliminado

		adapter = dao.consultarListaLugares(getActivity(), null);
		lstLugares.setAdapter(adapter);

		super.onResume();
	}

}
