package com.coixinera.footprintscollector;

import android.net.Uri;

import com.google.android.gms.maps.model.LatLng;

//Clase tipo POJO para crear objetos de tipo Lugar con sus propiedades debidamente encapsuladas.
//Los objetos tipo Lugar son los utilizados durante toda la aplicacin para manejar
//los datos de lugares introducidos

public class Lugar {

	private int _id;
	private String nombre;
	private String descripcion;
	private LatLng coordenadas;
	private Uri foto;

	public Lugar() {
	}

	public Lugar(String nombre, String descripcion, LatLng coordenadas, Uri foto) {
		this.nombre = nombre;
		this.descripcion = descripcion;
		this.coordenadas = coordenadas;
		this.foto = foto;
	}

	public Lugar(int _id, String nombre, String descripcion,
			LatLng coordenadas, Uri foto) {
		this.nombre = nombre;
		this.descripcion = descripcion;
		this.coordenadas = coordenadas;
		this.foto = foto;
		this._id = _id;

	}

	public int get_id() {
		return _id;
	}

	public void set_id(int _id) {
		this._id = _id;
	}

	public String getNombre() {
		return nombre;
	}

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	public String getDescripcion() {
		return descripcion;
	}

	public void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
	}

	public LatLng getCoordenadas() {
		return coordenadas;
	}

	public void setCoordenadas(LatLng coordenadas) {
		this.coordenadas = coordenadas;
	}

	public Uri getFoto() {
		return foto;
	}

	public void setFoto(Uri foto) {
		this.foto = foto;
	}
}
