package com.coixinera.footprintscollector;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.location.Location;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentActivity;
import android.support.v4.app.FragmentManager;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.coixinera.footprintsDB.FootPrints_DAO;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.LatLngBounds;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;

//Clase que muestra un Mapa GoogleMap en pantalla con todos los marcadores correspondientes a
//los lugares guardados en la base de datos.

public class MapaLugares_Fragment extends Fragment {

	private GoogleMap mapa;
	Marker m;
	ArrayList<Lugar> lugares;
	ArrayList<LatLng> ListaCoordenadas = new ArrayList<LatLng>();
	LatLngBounds bounds;
	HashMap<String, Integer> markersLugares = new HashMap<String, Integer>();
	int idLugar;

	ArrayList<MarkerOptions> listaMarkers = new ArrayList<MarkerOptions>();
	FootPrints_DAO dao = new FootPrints_DAO();

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		return inflater.inflate(R.layout.mapa_lugares_fragment, container,
				false);
	}

	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		// TODO Auto-generated method stub

		super.onActivityCreated(savedInstanceState);
		final SharedPreferences pref = PreferenceManager
				.getDefaultSharedPreferences(getActivity());

		lugares = dao.consultarMapaLugares(getActivity());

		for (Object element : lugares) {
			Lugar lugar = (Lugar) element;
			ListaCoordenadas.add(lugar.getCoordenadas());
		}
		LatLngBounds.Builder builder = new LatLngBounds.Builder();
		for (LatLng coord : ListaCoordenadas) {
			builder.include(coord);
		}
		bounds = builder.build();

		FragmentActivity fragmentActivity = getActivity();

		FragmentManager fm = fragmentActivity.getSupportFragmentManager();

		// recuperamos y asignamos una instancia de GoogleMap al fragment del
		// mapa
		mapa = ((SupportMapFragment) fm
				.findFragmentById(R.id.frgmap_mapa_lugares)).getMap();

		// podremos ver nuestra localizacin a parte de los marcadores
		mapa.setMyLocationEnabled(true);

		// mtodo que recupera los lugares de la base de datos y los muestra en
		// el mapa en forma de marcadores

		mapa.setOnMapClickListener(new GoogleMap.OnMapClickListener() {

			@Override
			public void onMapClick(LatLng coordenadas) {
				// hemos hecho click en un punto del mapa. La aplicacin
				// interpreta que queremos crear un lugar nuevo en las
				// coordenadas del mapa correspondientes al punto donde hemos
				// hecho click. Lanzamos la Actvity EditarLugar (que tambien
				// sirve para crear), pasandole las coordenadas del punto donde
				// hemos hecho click.
				Intent i = new Intent();
				i.putExtra("latitud", coordenadas.latitude);
				i.putExtra("longitud", coordenadas.longitude);
				i.setClass(getActivity(), EditarLugar_Activity.class);
				startActivity(i);

			}
		});

		mapa.setOnMarkerDragListener(new GoogleMap.OnMarkerDragListener() {

			@Override
			public void onMarkerDragStart(Marker marker) {
			}

			@Override
			public void onMarkerDragEnd(Marker m) {

				final Marker marker = m;
				// recupero el Id de lugar correspondiente de la base de datos a
				// travs del id del marker del mapa, utilizando el HashMap que
				// cree en el momento de poner los markers
				Iterator it = markersLugares.entrySet().iterator();
				while (it.hasNext()) {
					Map.Entry par = (Map.Entry) it.next();
					if (par.getKey().toString().equals(marker.getId())) {
						idLugar = (Integer) par.getValue();
					}

				}

				AlertDialog.Builder builder = new AlertDialog.Builder(
						getActivity());
				builder.setMessage(R.string.confirma_nuevas_coordenadas);
				builder.setPositiveButton(R.string.si,
						new AlertDialog.OnClickListener() {

							@Override
							public void onClick(DialogInterface dialog,
									int which) {

								dao.actualizarPosicionLugar(getActivity(),
										marker.getPosition(), idLugar);

							}

						});

				builder.setNegativeButton(R.string.no,
						new AlertDialog.OnClickListener() {

							@Override
							public void onClick(DialogInterface dialog,
									int which) {
								Lugar lugar = new Lugar();
								lugar = dao.consultarLugar(idLugar,
										getActivity());
								marker.setPosition(lugar.getCoordenadas());
							}
						});

				builder.create().show();

				// dao.actualizarPosicionLugar(getActivity(),
				// marker.getPosition(), coordenadasViejas);
			}

			@Override
			public void onMarkerDrag(Marker marker) {

			}

		});

		mapa.setOnInfoWindowClickListener(new GoogleMap.OnInfoWindowClickListener() {
			// asignamos comportamiento de click en Snippet. llevar a la
			// activity de ver Lugar.
			@Override
			public void onInfoWindowClick(Marker marker) {
				// recupero el Id de lugar correspondiente de la base de datos a
				// travs del id del marker del mapa, utilizando el HashMap que
				// cree en el momento de poner los markers
				Iterator it = markersLugares.entrySet().iterator();
				while (it.hasNext()) {
					Map.Entry par = (Map.Entry) it.next();
					if (par.getKey().toString().equals(marker.getId())) {
						idLugar = (Integer) par.getValue();
					}

				}
				// lanzamos la activity de Mostarlugar pasandole el IdLugar que
				// hemos recuperado.
				Intent intent = new Intent();
				intent.putExtra("id", idLugar);
				intent.setClass(getActivity(), MostrarLugar_Activity.class);
				startActivity(intent);

			}
		});

	}

	@Override
	public void onResume() {
		// venimos de estar en segundo plano. redibujamos los marcadores por si
		// algun dato ha cambiado
		final SharedPreferences pref = PreferenceManager
				.getDefaultSharedPreferences(getActivity());
		int TipoMapa = Integer.valueOf(pref.getString("mapa", "1"));

		mapa.setMapType(TipoMapa);

		mapa.setOnMapLoadedCallback(new GoogleMap.OnMapLoadedCallback() {

			@Override
			public void onMapLoaded() {
				int centradoMapa = Integer.valueOf(pref.getString("centrado",
						"1"));
				switch (centradoMapa) {
				case 1:
					mapa.animateCamera(CameraUpdateFactory.newLatLngBounds(
							bounds, 50));
					break;
				case 2:
					mapa.animateCamera(CameraUpdateFactory.newLatLngZoom(
							dao.ConsultarUltimoLugar(getActivity()), 10));
					break;

				default:
					break;
				}

				lugares = dao.consultarMapaLugares(getActivity());
				mostrarMarcadores();

			}
		});
		super.onResume();
	}

	private void mostrarMarcadores() {

		// mtodo que utiliza el DAO para recuperar todos los lugares en la base
		// de datos en un ArrayList. Posteriormente recorro el arrayList y voy
		// creando en el mapa los marcadores correspondientes a los lugares
		// recuperados

		Iterator it = lugares.iterator();

		while (it.hasNext()) {
			Lugar lugar = (Lugar) it.next();
			LatLng coordenadas = lugar.getCoordenadas();
			MarkerOptions marker = new MarkerOptions();
			marker.position(coordenadas);
			marker.title(lugar.getNombre());
			marker.snippet(lugar.getDescripcion());

			// marker.icon(BitmapDescriptorFactory
			// .defaultMarker(BitmapDescriptorFactory.HUE_RED));
			marker.icon(BitmapDescriptorFactory.fromResource(R.drawable.marker));
			marker.draggable(true);
			listaMarkers.add(marker);
			// mapa.addMarker(marker);
			animacionEntradaMarker(marker, lugar);

		}

	}

	private void animacionEntradaMarker(MarkerOptions marker, Lugar lugar) {

		Marker m1 = mapa.addMarker(marker);
		// me guardo una referencia de cada marker para saber que ID de lugar
		// tiene en la base de datos
		markersLugares.put(m1.getId(), lugar.get_id());

	}

	private Location convertLatLngToLocation(LatLng latLng) {
		Location location = new Location("someLoc");
		location.setLatitude(latLng.latitude);
		location.setLongitude(latLng.longitude);
		return location;
	}

	private float bearingBetweenLatLngs(LatLng beginLatLng, LatLng endLatLng) {
		Location beginLocation = convertLatLngToLocation(beginLatLng);
		Location endLocation = convertLatLngToLocation(endLatLng);
		return beginLocation.bearingTo(endLocation);
	}

}
