package com.coixinera.footprintscollector;

import android.content.Intent;
import android.location.Criteria;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.Toast;

public class MenuEntrada_Fragment extends Fragment implements OnClickListener {

	Button btnListaLugares, btnMapaLugares, btnAgregarEsteLugar;
	LocationManager locManager;
	LocationListener locListener;
	Location loc;
	boolean providerEnabled = false;

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {

		return inflater.inflate(R.layout.menu_entrada_fragment, container,
				false);

	}

	@Override
	public void onActivityCreated(Bundle savedInstanceState) {

		super.onActivityCreated(savedInstanceState);

		// esta es la pantalla del men de entrada con simplemente dos botones
		// que lanzan la activity correspondiente a la opcin seleccionada, ya
		// sea ver la lista de lugares o ver los lugares en el mapa
		View vista = getView();

		btnListaLugares = (Button) vista.findViewById(R.id.btn_lista_lugares);
		btnMapaLugares = (Button) vista.findViewById(R.id.btn_mapa_lugares);
		btnAgregarEsteLugar = (Button) vista
				.findViewById(R.id.btn_agregar_lugar);

		btnListaLugares.setOnClickListener(this);
		btnMapaLugares.setOnClickListener(this);
		btnAgregarEsteLugar.setOnClickListener(this);

		locManager = (LocationManager) getActivity().getSystemService(
				getActivity().LOCATION_SERVICE);

		Criteria req = new Criteria();
		req.setAccuracy(Criteria.NO_REQUIREMENT);
		String gpsProvider = locManager.getBestProvider(req, false);

		loc = locManager.getLastKnownLocation(gpsProvider);
		providerEnabled = locManager.isProviderEnabled(gpsProvider);
		locListener = new LocationListener() {

			@Override
			public void onStatusChanged(String provider, int status,
					Bundle extras) {

			}

			@Override
			public void onProviderEnabled(String provider) {

				providerEnabled = true;
			}

			@Override
			public void onProviderDisabled(String provider) {

				providerEnabled = false;
			}

			@Override
			public void onLocationChanged(Location location) {
				loc = location;

			}
		};

		locManager.requestLocationUpdates(gpsProvider, 5000, 0, locListener);

	}

	@Override
	public void onClick(View v) {

		Intent i = new Intent();

		switch (v.getId()) {
		case R.id.btn_lista_lugares:

			i.setClass(getActivity(), ListaLugares_Activity.class);
			startActivity(i);
			break;

		case R.id.btn_mapa_lugares:
			i.setClass(getActivity(), MapaLugares_Activity.class);
			startActivity(i);
			break;
		// MEJORA: Agregamos opcin en men principal que sirve para
		// directamente crear un Lugar en la ubicacin en la que estamos en este
		// momento. iniciamos editarLugar activity pasandole las coordenadas de
		// la ubicacin actual. Para ello utilizamos los datos Capturados a
		// travs del Location Listener que hemos configurado antes
		case R.id.btn_agregar_lugar:

			if (providerEnabled && loc != null) {
				i.setClass(getActivity(), EditarLugar_Activity.class);
				i.putExtra("latitud", loc.getLatitude());
				i.putExtra("longitud", loc.getLongitude());
				startActivity(i);
			} else {

				Toast.makeText(getActivity(),
						R.string.error_posicion_no_encontrada,
						Toast.LENGTH_SHORT).show();

			}

			break;

		default:
			break;
		}

	}
}
