package com.coixinera.footprintscollector;

import android.content.Intent;
import android.graphics.Bitmap;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.text.SpannableString;
import android.text.style.UnderlineSpan;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import com.coixinera.footprintsDB.FootPrints_DAO;

public class MostrarLugar_Fragment extends Fragment {

	TextView txtTitulo, txtDescripcion;
	ImageView imgFotoLugar;
	Button btnEditarLugar, btnIrALugar;
	FootPrints_DAO dao = new FootPrints_DAO();

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		return inflater.inflate(R.layout.mostrar_lugar_fragment, container,
				false);
	}

	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		// Clase que recupera el id del lugar pasado, consulta los datos del
		// lugar a travs del DAO y los muestra en la activity
		super.onActivityCreated(savedInstanceState);

		final int idLugar = getActivity().getIntent().getExtras().getInt("id");
		final Long jj = getActivity().getIntent().getExtras().getLong("id");
		View vista = getView();

		txtTitulo = (TextView) vista.findViewById(R.id.txt_titulolugar);
		txtDescripcion = (TextView) vista
				.findViewById(R.id.txt_descripcionlugar);
		imgFotoLugar = (ImageView) vista.findViewById(R.id.img_fotolugar);
		btnEditarLugar = (Button) vista.findViewById(R.id.btn_editar_lugar);

		btnEditarLugar.setOnClickListener(new Button.OnClickListener() {
			// iniciamos activity de edicin, pasandole tambien, para que sepa
			// cual es el lugar que hay que editar
			@Override
			public void onClick(View v) {
				Intent i = new Intent();
				i.putExtra("id", idLugar);
				i.setClass(getActivity(), EditarLugar_Activity.class);
				startActivityForResult(i, 1000);
			}
		});

		// consultamos el Lugar escogido, y cargamos los datos del mismo en la
		// activity
		Lugar lugar = dao.consultarLugar(idLugar, getActivity());

		SpannableString titulo = new SpannableString(lugar.getNombre());
		titulo.setSpan(new UnderlineSpan(), 0, titulo.length(), 0);
		txtTitulo.setText(titulo);

		txtDescripcion.setText(lugar.getDescripcion());
		// llamamos a nuestra clase auxiliar generadora de bitmaps para cargar
		// el bitmap con la Uri facilitada
		Bitmap bitmap = BitmapGetter.getBitmap(lugar.getFoto(), getActivity());
		if (bitmap != null) {
			imgFotoLugar.setImageBitmap(bitmap);
		}

	}

}
